package com.llisoft.pay.config;

import com.llisoft.pay.common.CodeEnum;

/**
 * 自定义业务异常
 * @author YangJie [2019年1月4日]
 */
@SuppressWarnings("serial")
public class MtaException extends RuntimeException {
	
	private CodeEnum codeEnum;

	
	public MtaException(String msg) {
		super(msg);
	}

	public MtaException(CodeEnum codeEnum) {
		super(codeEnum.getMsg());
		this.codeEnum = codeEnum;
	}

	
	public static MtaException build(String msg) {
		return new MtaException(msg);
	}
	
	public static MtaException build(CodeEnum codeEnum) {
		return new MtaException(codeEnum);
	}
	

	public CodeEnum getCodeEnum() {
		return codeEnum;
	}

}
