package com.llisoft.pay.controller;

import java.nio.charset.StandardCharsets;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.util.StreamUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.llisoft.pay.service.PayWxService;
import com.llisoft.pay.util.XmlUtil;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@Api(tags="微信支付回调")
@Controller
@RequestMapping("/wxpay")
@Deprecated // 升级SDKv3 > CallbackWxPayController
public class WxPayController {
	
	private Logger logger = LoggerFactory.getLogger(WxPayController.class);

	@Autowired
	private PayWxService wxPayService;
	
	
	@ApiOperation(value="异步通知")
	@PostMapping(value="/notify")
	public @ResponseBody String notify(HttpServletRequest request) throws Exception {
		// https://pay.weixin.qq.com/wiki/doc/api/jsapi.php?chapter=9_7&index=8
		String xml = StreamUtils.copyToString(request.getInputStream(), StandardCharsets.UTF_8);
		logger.debug("收到微信异步通知: {}", xml);
		Map<String, String> resultMap = XmlUtil.toObject(xml, Map.class, String.class, String.class);
		logger.debug("解析异步通知内容: {}", resultMap);
		return wxPayService.dispose(resultMap) ? "success" : "";
	}
	
}